# Copyright (C) 2014 Canonical Ltd.
# Author: Michael Vogt

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""Search for Click packages"""

from __future__ import print_function

from optparse import OptionParser
import sys
from textwrap import dedent

from click.repository import (
    get_repository,
    ClickRepositoryError,
)


def run(argv):
    parser = OptionParser(dedent("""\
        %prog search search-term(s)

        """))
    options, args = parser.parse_args(argv)
    if len(args) < 1:
        parser.error("need package file name")
    repo = get_repository()
    try:
        result = repo.search(args[0])
    except ClickRepositoryError as e:
        print("Search failed %s" % e, file=sys.stderr)
        return 1
    for app in result:
        print("%s - %s" % (app["name"], app["title"]))
    return 0
