# Copyright (C) 2014 Canonical Ltd.
# Author: Michael Vogt <mvo@ubuntu.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import oauthlib.oauth1


def get_oauth_headers_for_uri(uri, token):
    client = oauthlib.oauth1.Client(token["consumer_key"],
                                    token["consumer_secret"],
                                    token["token_key"],
                                    token["token_secret"])
    new_uri, headers, body = client.sign(uri)
    if new_uri != uri:
        raise Exception("uri change not supported")
    if body is not None:
        raise Exception("body != None not supported")
    return headers
